# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

import sys
__all__ = [
    'contextmanager',
    'nested',
    'closing']

class GeneratorContextManager(object):
    
    def __init__(self, gen):
        self.gen = gen

    
    def __enter__(self):
        
        try:
            return self.gen.next()
        except StopIteration:
            raise RuntimeError("generator didn't yield")


    
    def __exit__(self, type, value, traceback):
        if type is None:
            
            try:
                self.gen.next()
            except StopIteration:
                return None

            raise RuntimeError("generator didn't stop")
        elif value is None:
            value = type()
        
        
        try:
            self.gen.throw(type, value, traceback)
            raise RuntimeError("generator didn't stop after throw()")
        except StopIteration:
            exc = None
            return exc is not value
        except:
            if sys.exc_info()[1] is not value:
                raise 
            




def contextmanager(func):
    
    def helper(*args, **kwds):
        return GeneratorContextManager(func(*args, **kwds))

    
    try:
        helper.__name__ = func.__name__
        helper.__doc__ = func.__doc__
        helper.__dict__ = func.__dict__
    except:
        (None,)

    return helper


def nested(*managers):
    exits = []
    vars = []
    exc = (None, None, None)
    
    try:
        for mgr in managers:
            exit = mgr.__exit__
            enter = mgr.__enter__
            vars.append(enter())
            exits.append(exit)
        
        yield vars
    except:
        exc = sys.exc_info()
    finally:
        while exits:
            exit = exits.pop()
            
            try:
                if exit(*exc):
                    exc = (None, None, None)
            continue
            exc = sys.exc_info()
            continue

        if exc != (None, None, None):
            raise exc[0], exc[1], exc[2]
        


nested = contextmanager(nested)

class closing(object):
    
    def __init__(self, thing):
        self.thing = thing

    
    def __enter__(self):
        return self.thing

    
    def __exit__(self, *exc_info):
        self.thing.close()


